require 'rest-client'
require 'json'
require 'time'

module Trader
  class ItbitBackend < BaseBackend
    def fill_book(_book)
      # TODO: consider book pair

      _book.prepare Time.now

      ob = fetch_raw_order_book _book.pair
      ob['bids'].each { |o| _book.add_bid(o[0], o[1]) }
      ob['asks'].each { |o| _book.add_ask(o[0], o[1]) }

      tx = fetch_raw_transactions _book.pair
      tx['recentTrades'].each do |t|
        _book.add_transaction t['price'], t['amount'], Time.parse(t['timestamp'])
      end
    end

    def get_available_markets
      # TODO.
    end

    def get_session(_credentials)
      _credentials
    end

    def get_balance(_session, _currency)
      return Price.new(_currency, 0.0) if _currency.code == :BTC
      return Price.new(_currency, 20000.0) if _currency.code == :USD
    end

    def get_orders(_session, _pair)
    end

    def create_order(_session, _pair, _volume, _price, _type)
    end

    def fetch_order(_session, _order)
    end

    def cancel_order(_session, _order)
    end

    private

    def fetch_raw_order_book(_pair)
      JSON.parse(RestClient.get "https://api.itbit.com/v1/markets/XBTUSD/order_book")
    end

    def fetch_raw_transactions(_pair)
      JSON.parse(RestClient.get "https://api.itbit.com/v1/markets/XBTUSD/trades")
    end
  end
end