module Trader
  class CompoundConverter < Converter
    attr_accessor :converters

    def initialize(_converters)
      @converters = _converters
    end

    def apply(_value, _invert=false)
      unless _invert
        converters.inject(_value) { |r, c| c.apply(r, false) }
      else
        converters.reverse.inject(_value) { |r, c| c.apply(r, true) }
      end
    end
  end
end