module Trader
  class InverseConverter < Converter
    attr_reader :other

    def initialize(_other)
      @other = _other
    end

    def current_rate
      return nil if other.current_rate.nil?
      1.0 / other.current_rate
    end

    def apply(_value, _invert=false)
      @other.apply(_value, !_invert)
    end
  end
end