module Trader
  class AccountProxy
    attr_reader :account, :proxy, :pair

    def initialize(_account, _proxy, _pair)
      @account = _account
      @proxy = _proxy
      @pair = _pair
    end

    def backend
      account.backend
    end

    def market
      account.market_for proxy # TODO: market conversion
    end

    def base_balance
      balance = account.balance_for proxy.base
      balance.convert_to pair.base
    end

    def quote_balance
      balance = account.balance_for proxy.quote
      balance.convert_to pair.quote
    end

    def bid(_volume, _price=nil)
      order = Order.new_bid(pair, _volume, _price).convert_to proxy
      account.create_order(order).convert_to pair
    end

    def ask(_volume, _price=nil)
      order = Order.new_ask(pair, _volume, _price).convert_to proxy
      account.create_order(order).convert_to pair
    end

    def find_order(_id)
      account.find_order(_id).convert_to pair
    end

    def list_orders()
      # TODO
    end
  end
end